angular.module('app.controllers')

.controller('loginCtrl', ['$window','$scope', '$stateParams', 'Globales', '$ionicPopup', '$state', '$http','$cordovaPush',
'$ionicHistory', '$translate', '$cordovaDialogs', '$timeout', 'Saving','$ionicPlatform', 'Option','segment', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($window, $scope, $stateParams, Globales, $ionicPopup, $state, $http, $cordovaPush, 
    $ionicHistory, $translate, $cordovaDialogs, $timeout, Saving, $ionicPlatform, Option,segment) {
    var analytics = segment;
    var storage = window.localStorage;

    $scope.submitting = false;
    $scope.keyboardOpen = false;
    $scope.styleInput = {
        position: "absolute",
        top: '40vh'
    }
    $scope.styleButton = {
        bottom: '10vh'
    }
    $scope.styleButtonSubmit = {
        bottom: '20vh'
    }
    $scope.styleLink = {
        bottom: '3vh'
    }
    $scope.classBackgroundStyle = {
            height:  window.innerHeight+"px"
    };

    var keyboardShowHandler = function(open){
        $scope.$apply(function(){$scope.keyboardOpen = open;});
        if (open) {
            $scope.$apply(function(){$scope.styleInput.top = '10vh';});
            if(ionic.Platform.isIOS()){ 
                console.log("up"); 
                $scope.$apply(function(){$scope.styleInput.top= '40vh';});
            } 
            $scope.$apply(function(){$scope.styleButton.display= 'none';});
            $scope.$apply(function(){$scope.styleButtonSubmit.display= 'none';});
            $scope.$apply(function(){$scope.styleLink.display= 'none';});
        }
        else{
            $scope.$apply(function(){$scope.styleInput.top = '40vh';});
            //if(ionic.Platform.isIOS()){
                $scope.$apply(function(){$scope.styleButton.bottom= '10vh';});
                $scope.$apply(function(){$scope.styleButtonSubmit.bottom= '20vh';});
                $scope.$apply(function(){$scope.styleLink.bottom= '3vh';});
            //}
            $scope.$apply(function(){$scope.styleButton.display= 'block';});
            $scope.$apply(function(){$scope.styleButtonSubmit.display= 'block';});
            $scope.$apply(function(){$scope.styleLink.display= 'block';});
        }
        console.log("hello" + open)
    }
    var kSHTrue = function(){keyboardShowHandler(true);};
    var kSHFalse = function(){keyboardShowHandler(false);};

    $scope.securLog = {
        Email: storage.getItem('Email'),
        Password: ''
    }
    var onLoadFunctLogin = function(){
        window.removeEventListener('native.keyboardshow', kSHTrue);
        window.removeEventListener('native.keyboardhide', kSHFalse);
        window.addEventListener('native.keyboardshow', kSHTrue);
        window.addEventListener('native.keyboardhide', kSHFalse);

        console.log("Login");
        ionic.keyboard.disable();
    }

    $scope.$on("$ionicView.beforeEnter",onLoadFunctLogin);

    //if(typeof analytics !== 'undefined') { analytics.trackView($ionicHistory.currentStateName()); }
    console.log("ctrlLogin")
    if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName());}

    $scope.resetPassword = function(){

        console.log("hello : " + $scope.securLog.Email);
        if(!validateEmail($scope.securLog.Email)){
            $cordovaDialogs.alert($translate.instant("YOUREMAILISWRONG"), $translate.instant("ERROR"));
        }
        else{
            Globales.resetPSW($scope.securLog.Email).then(function(data){
                if(data == 1){
                    console.log("ok");
                    $cordovaDialogs.alert($translate.instant("YOUWILLRECEIVEAMAILSOON"), $translate.instant("RESETPSW"));
                }
                else{
                    console.log("nope");
                    $cordovaDialogs.alert($translate.instant("YOUEMAILISUNKNOWN"), $translate.instant("ERROR"));
                }
            })
        }
    }

    var redirect = function(){
        //$state.go('myLuko.consumption');
        //return;
        var res = Globales.getHardwareStatus(storage.token).then(function(data){
            if (data==0){
                console.log("Error in hardware status1")
                $cordovaDialogs.alert($translate.instant('ANERRORHAPPEN'), $translate.instant('ERROR'), "OK");
                //$cordovaDialogs.alert($translate.instant('ANERRORHAPPEN'), 'Hello', "OK");
                return 0;
            }
            else if (data.data==0){
                console.log("Error in hardware status2")
                $state.go('myLuko.settings');
                return 1;
            }
            else{
                data = data.data;
                console.log(data);
                if (data.sensor_id){
                    console.log("redirect: Sensor ID ok")
                    return 0;
                } else {
                    console.log("redirect: Go to settings")
                    $state.go('myLuko.settings');
                    return 1;
                }
            }
            return 0;
        });
        console.log("Res redirect: " + res);
        return res;
    }



    $scope.submit = function(){
        console.log("submitting ...");
        if($scope.submitting){
            console.log("already submitting something ...");
            return
        }

        $scope.submitting = true;

        storage.Email = $scope.securLog.Email;


        Globales.logIn($scope.securLog).then(function(out){
            if(out == 0){
                $scope.submitting = false;
                $cordovaDialogs.alert($translate.instant('ERRORFROMCONNECTIONSERVEUR'), $translate.instant("SORRY"));
            }
            else{
                console.log("out login")
                console.log(out)
                if(out.good === 1){
                    $scope.submitting = false;
                    var datapass = {
                        key : out.token
                    };
                    $scope.securLog = {
                        Email: storage.getItem('Email'),
                        Password: '',
                    };
                    if(ionic.Platform.isIOS()){
                      var platformString = "IOS";
                    }
                    else if (ionic.Platform.isAndroid()){
                      var platformString = "GCM";
                    }
                    else{
                      var platformString = "OTHER";
                    }
                    storage.setItem('token', out.token); // Pass a key name and its value to add or update that key.
                    Saving.save(null);
                    try{
                        cordova.getAppVersion.getVersionNumber().then(function (version) {
                          $http.post('https://app.getluko.com/msg/subscribePush', {token: storage.registrationId, platform: platformString, user_id: storage.token, appversion: version, language: $translate.use()})
                          .success(function(data){
                          })
                          .error(function(err){
                          });
                        });
                    }
                    catch(err){
                        console.log("No app version : no notification !!");
                    }
                    //if(typeof analytics !== 'undefined') { analytics.setUserId(storage.Email);}
                    analytics.identify(storage.Email, {
                        name: storage.userName,
                        email: storage.Email
                    });

                    if(typeof intercom !== 'undefined') { 
                      intercom.registerIdentifiedUser({email: storage.Email}); 
                    } 
                    console.log("storage : " + storage.introDone)

                    if (!(storage.isLukoValidated)){ 
                      Option.getDeviceID(storage.token).then(function(resp){ 
                        console.log("resp : " + resp);
                        if (resp){ 
                          console.log("luko validation : " + resp);
                          storage.isLukoValidated = true; 
                        } 
                        console.log("storage1 : " + storage.introDone) 
                        if (!storage.introDone && !storage.isLukoValidated) { 
                          console.log("Start with intro1"); 
                          $state.go('myLuko.intro').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                        } 
                        else { 
                            redirect().then(function(redirect){
                                console.log("Redirect : " + redirect);
                                if (redirect == 1) {
                                    $state.go('myLuko.settings').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}});
                                } else {
                                    console.log("Start with consumption"); 
                                    $state.go('myLuko.consumption').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                                    //$state.go('myLuko.intro').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                                }
                            });
                        } 
                      }) 
                    } else { 
                        console.log("storage2 : " + storage.isLukoValidated) 
                        console.log("storage2 : " + storage.introDone) 
                        if (!storage.introDone && !storage.isLukoValidated) { 
                          console.log("Start with intro2"); 
                          $state.go('myLuko.intro').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                        } 
                        else { 
                            redirect().then(function(redirect){
                                console.log("Redirect : " + redirect);
                                if (redirect == 1) {
                                    $state.go('myLuko.settings').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}});
                                } else {
                                    console.log("Start with consumption"); 
                                    $state.go('myLuko.consumption').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                                    //$state.go('myLuko.intro').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                                }
                            });
                        } 
                    }
                }
                else {
                    $scope.submitting = false;
                    $cordovaDialogs.alert($translate.instant('YOUREMAILORPASSWORDISWRONG'), $translate.instant("SADLY"));
                }
            }

        })

    }
    $scope.signUp = function(){
        try{window.Keyboard.close();}
        catch(err){console.log("no keyboard : " + JSON.stringify(err));}
        $timeout(function(){$state.go('signUp')},200);
    }
    function validateEmail(email) {var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;return re.test(email);}

}])
