angular.module('app.controllers')

.controller('consumptionCtrl', ['$scope', '$stateParams', '$ionicPopup', 'Globales', '$state', '$timeout', '$ionicHistory', 'Option', '$translate', 'Price', 
'Saving', '$cordovaDialogs', '$ionicLoading','Pricing','segment', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller

// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $ionicPopup, Globales, $state, $timeout, $ionicHistory, Option, $translate, Price, 
  Saving, $cordovaDialogs, $ionicLoading, Pricing,segment) {

  var analytics = segment;
  // GEt local storage for credentials
  var storage = window.localStorage;
  var token = function(){ return "Token " + storage.token; }
  var resConsumption = [];
  var waiting_res = 1;
  var resConsumptionForecast = [];
  var waiting_res_forecast = 1;
  storage.api_key = "877d252fa35a43cbe82a11d74bc37faef7cc6d3fb9724d1ce3e2e5160a9f0604", 
  Saving.save(null);
  $scope.fullscreen = false;
  $scope.notBubble = true;

  // Define parameters for LukoGraph class
  var param_object = {
    registration_token: token,
    api_key: storage.api_key,
    api_endpoint: "https://app.getluko.com/v1/consumption",
    container: ".cons-graph",
    translate: $translate,
    menuItems: {
      'NOW':    { 'active': true, 'unit': 'W' },
      'TODAY':  { 'active': true, 'unit': 'Wh' },
      '7DAYS':  { 'active': true, 'unit': 'Wh' },
      '30DAYS': { 'active': true, 'unit': 'Wh' },
      'YEAR':   { 'active': true, 'unit': 'Wh' }
    }
  };

  // Initialize LukoGraph Class
  var luko_graph = LukoGraph(param_object);

  // Set onChange function for LukoGraph Class
  var graph_changed = function(change){
    if(change.type == "menu"){
      if(change.value == 0){
        console.log("toggle");
        $scope.toggleGraph(0);
        }
      }
  }
  luko_graph.on_change(graph_changed);

  // Set luko_graph price function to bar chart
  var price_calculator = function(data){
    console.log(data);
    var schedule = JSON.parse(storage.contract).low_cost_time
    console.log("schedule : ", schedule)
    resConsumption = [];
    waiting_res=1;
    var lastDate = getLastDate();
    if (Date.now() - lastDate*1000 > 3600000 || !lastDate){
      console.log("more than an hour")
      if(!lastDate){lastDate=Math.round(Date.parse('January 1, 2017 12:59:00')/1000);}
      getAllConsumption(lastDate);
    }
    var allConsumption = JSON.parse(storage.allConsumption)
    var allForecast = JSON.parse(storage.allForecast)
    var price_data = JSON.parse(JSON.parse(storage.contract).price);
    var price_hour = price_data[0];
    var price_abo = price_data[1];
    var price_total = 0;
    var date = new Date(data.date);
    var time = date.getTime() / 1000;
    var id = $scope.timeActive;
    if (data.todayprice) { id = "default";}
    if (data.monthprice) { id = 4}
    switch(id){
      case 1:
        console.log("heure");
        price_total += price_abo / (365*24) ;
        price_total += hourCost(data,price_hour,schedule,time, allConsumption,allForecast)
        break;

      case 4:
        console.log("mois");
        price_total += price_abo / 12 ;        var numberOfDays = 30;
        if(date.getMonth() in [1,3,5,7,8,10,12]) {numberOfDays = 31;}
        if(date.getMonth()==2) {numberOfDays = 28;}
        for(l=0; l<24*numberOfDays; l++){
          price_total += hourCost(data,price_hour,schedule,time+l*3600,allConsumption,allForecast);
        }
        break;

      default:
        console.log("jour");
        price_total += price_abo / 365 ;
        for(k=0; k<24; k++){
          //console.log(price_total)
          price_total += hourCost(data,price_hour,schedule,time+k*3600,allConsumption,allForecast);
        }
        break;
    }
    return Price.cur(price_total); 
 }
  luko_graph.set.price_function(price_calculator);


  // Get hour cost
  var hourCost = function(data,price_hour,schedule,time, allConsumption, allForecast){
    var date = new Date(time*1000);
    var hour = date.getHours();
    var hour_price = 0.1593;
    var value = 0;
    if (price_hour.length > 1){
      hour_price = priceHour(hour,price_hour,schedule)
    } else {
      hour_price = price_hour;
    }
    if (data.id == "forecast"){
      if (!allForecast[time]){
        if (time*1000 < Date.now()){
          while(!allForecast[time]){
            time += 365*24*60*60 
          }
        } else {
          while(!allForecast[time]){
            time -= 365*24*60*60 
          }
        }
      }
      try{
        allForecast[time];
      }catch(err){
        time -= 365*24*60*60 
      }
      value = hour_price*allForecast[time] /1000;
      if (!value){value=0;}
    } else {
      value = hour_price*allConsumption[time] /1000;
      if (!value){
        value=0;
      }
    }
    //console.log(time)
    //console.log(value)
    return value; 
  }
  var isTrackingTime = false;
  // Function called when menu item is toggled
  $scope.toggleTime = function(id) {
    console.log("Toggle time : ", id)
    var graph = ""
    switch(id){
      case 0:
        graph =":NOW";
        break;
      case 1:
        graph = ":TODAY";
        break;
      case 2:
        graph =":7DAYS";
        break;
      case 3:
        graph = ":30DAYS";
        break;
      case 4:
        graph = ":YEAR";
        break;
      default:
        break;
    }

    if (isTrackingTime == false){
      isTrackingTime = true;
      if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName() + graph);}
      $timeout(isTrackingTime=false, 1000);
    }

    // If now was clicked, change to line chart
    if((id == 0) && ($scope.graphActive == 0)){ 
      $scope.toggleGraph(0); 
    }

    // Set time active to the clicked id
    $scope.timeActive = id;

    // Update cards
    $timeout(function(){ updateCard(); }, 200);

  }

  // Set luko_graph menu click function to toggleTime
  luko_graph.set.menu_click($scope.toggleTime);

  // Update luko_graph
  $scope.updateLukoGraph = function() {

    // Update luko_graph
    luko_graph.set.time_active($scope.timeActive);
    luko_graph.set.graph_active($scope.graphActive);

    // Update Menu
    luko_graph.update('menu', $scope.timeActive);

    // Update charts
    if($scope.graphActive == 0 || $scope.graphActive == 1){ luko_graph.update('chart', $scope.timeActive); }
  }

  // X-mas option
  $scope.totalIcon = "img/consumption/total.png";
  time = Date.now();
  if((time > Date.parse("2017-12-18"))&&(time < Date.parse("2018-01-07"))){
    $scope.totalIcon = "img/consumption/totalXmas.png"
  }

  //get price according to a special hour
  var priceHour = function(hour, price_hour, schedule){
    var off_peaks = false;
    if (!schedule){schedule=[[22,5]]}
    for (i=0; i<schedule.length; i++){
      var fork = schedule[i];
      var min = fork[0];
      var max = fork[1];
      if (max < min){
        var new_fork = [0,max];
        if (schedule[schedule.length-1][0]!=new_fork[0] || schedule[schedule.length-1][1]!=new_fork[1]){
            schedule.push(new_fork);
        }
        
        max = 24;
      }
      if (hour >= min && hour <= max ){
        off_peaks=true;
        break;
      }
    }

    //console.log("off_peaks : ", off_peaks)
    if(off_peaks==true){
      return price_hour[1]
    } else{
      return price_hour[0]
    }
  }


  //get last date records in allConsumption
  var getLastDate = function(){
    if (!storage.allConsumption){
      return Math.round(Date.parse('January 1, 2017 12:59:00')/1000);
    } else {
      var allConsumption = JSON.parse(storage.allConsumption);
      return parseInt(Object.keys(allConsumption)[Object.keys(allConsumption).length - 1]);
    }
  }


    // Set luko_graph price function to bar chart
  var consumption_calculator = function(data){
    console.log(data);
    resConsumption = [];
    waiting_res=1;
    var lastDate = getLastDate();
    if (Date.now() - lastDate*1000 > 3600000 || !lastDate){
      console.log("more than an hour")
      if(!lastDate){lastDate=Math.round(Date.parse('January 1, 2017 12:59:00')/1000);}
      getAllConsumption(lastDate);
    }
    var allConsumption = JSON.parse(storage.allConsumption)
    var allForecast = JSON.parse(storage.allForecast)
    var date = new Date(data.date);
    var time = date.getTime() / 1000;
    var id = $scope.timeActive;
    if (data.todayprice) { id = "default";}
    if (data.monthprice) { id = 4}
    var conso_total = 0 ;
    switch(id){
      case 1:
        console.log("heure get conso");
        var valueToAdd = allConsumption[time];
        if (valueToAdd){
            conso_total += valueToAdd;
        } 
        break;

      case 4:
        console.log("mois get conso");
        var numberOfDays = 30;
        if(date.getMonth() in [1,3,5,7,8,10,12]) {numberOfDays = 31;}
        if(date.getMonth()==2) {numberOfDays = 28;}
        for(l=0; l<24*numberOfDays; l++){
            var valueToAdd = allConsumption[time+l*3600];
            if (valueToAdd){
                conso_total += valueToAdd;
            } 
        }
        break;

      default:
        console.log("jour get conso");
        for(k=0; k<24; k++){
            var valueToAdd = allConsumption[time+k*3600];
            if (valueToAdd){
                conso_total += valueToAdd;
            } 
        }
        break;
    }
    return Price.formatLargeNumber(conso_total) + " kWh"; 
 }

  //get all consumption from date
  var getAllConsumption = function(date_start=Math.round(Date.parse('January 1, 2017 12:59:00')/1000),date_end=null){
    var data = {};
    if (date_end==null){
      var datenow = new Date();
      var minutesToCut = datenow.getMinutes();
      var secondsToCut = datenow.getSeconds();
      var carry = 0;
      if (secondsToCut > 0 ){ carry = 1;}
      var minutesToAdd = 59 - minutesToCut - carry;
      var secondsToAdd = 60 - secondsToCut;
      var beforeadd = Math.round(Date.now()/1000);
      date_end = beforeadd + 60 * minutesToAdd + secondsToAdd;
      if ((date_end % 2) == 1){
        date_end -= 1;
      }
    }
    data["start_date"]=date_start;
    data["end_date"]=date_end;
    var year_to_seconds = 365*24*60*60 ;
    //if query > one year consumption
    if (data["end_date"]-data["start_date"] > year_to_seconds){
      var previous_data = {};
      previous_data["start_date"] = Object.assign(data["start_date"])["[[PrimitiveValue]]"];
      previous_data["end_date"]= data["end_date"]-year_to_seconds;
      waiting_res =  waiting_res + 1;
      getAllConsumption(previous_data["start_date"],previous_data["end_date"], waiting_res);
      data["start_date"]=data["end_date"]-year_to_seconds+3600;
    }
    return Pricing.getAll(data).then(function(result){
      resConsumption.push(result);
      waiting_res = waiting_res - 1;
      if (waiting_res<1){
        reformatConsumption(resConsumption);
        return 0;
      }
      })
  }

  //get all forecast from date
  var getAllForecast = function(date_start=null,date_end=null){
    var data = {};
    var year_to_seconds = 365*24*60*60;
    if (date_start==null){
      var datenow = new Date();
      var minutesToCut = datenow.getMinutes();
      var secondsToCut = datenow.getSeconds();
      var carry = 0;
      if (secondsToCut > 0 ){ carry = 1;}
      var minutesToAdd = 59 - minutesToCut - carry;
      var secondsToAdd = 60 - secondsToCut;
      var beforeadd = Math.round(Date.now()/1000);
      date_start = beforeadd + 60 * minutesToAdd + secondsToAdd;
      if ((date_start % 2) == 1){
        date_start -= 1;
      }
    }
    data["start_date"]=date_start;
    if (date_end==null){
      date_end = date_start + year_to_seconds
    }
    data["end_date"]=date_end;
    //if query > one year consumption
    if (data["end_date"]-data["start_date"] > year_to_seconds){
      var previous_data = {};
      previous_data["start_date"] = Object.assign(data["start_date"])["[[PrimitiveValue]]"];
      previous_data["end_date"]= data["end_date"]-year_to_seconds;
      waiting_res_forecast =  waiting_res_forecast + 1;
      getAllConsumption(previous_data["start_date"],previous_data["end_date"], waiting_res);
      data["start_date"]=data["end_date"]-year_to_seconds+3600;
    }
    Pricing.getAllForecast(data).then(function(result){
      resConsumptionForecast.push(result);
      waiting_res_forecast = waiting_res_forecast - 1;
      if (waiting_res_forecast<1){
        reformatForecast(resConsumptionForecast);
      }
      })
  }

  //reformat and save consumption data
  function reformatConsumption(consumption){
    var year_consumption = [];
    var allConsumption = {};
    if (storage.allConsumption){
      allConsumption = JSON.parse(storage.allConsumption);
    }
    for(i=0; i<consumption.length; i++){
      //console.log("i : ", i)
      year_consumption=consumption[i];
      try {
        for (j=0; j<year_consumption.t.length; j++){
          allConsumption[year_consumption.t[j]]=year_consumption.w[j];
        }   
      } catch(err) {console.log("no data to reformat")}
    }
    storage.allConsumption = JSON.stringify(allConsumption);
    console.log(Object.keys(allConsumption).length)
    Saving.save(null);
  }

    //reformat and save forecast data
  function reformatForecast(consumption){
    var year_consumption = [];
    var allForecast = {};
    if (storage.allForecast){
      allForecast = JSON.parse(storage.allForecast);
    }
    for(i=0; i<consumption.length; i++){
      year_consumption=consumption[i];
      try {
        for (j=0; j<year_consumption.t.length; j++){
          allForecast[year_consumption.t[j]]=year_consumption.w[j];
        }   
      } catch(err) {console.log(err)}
    }
    storage.allForecast = JSON.stringify(allForecast);
    console.log(Object.keys(allForecast).length)
    Saving.save(null);
  }


  //precision round for pricing
  function precisionRound(number, precision) {
    var factor = Math.pow(10, precision);
    return Math.round(number * factor) / factor;
  }


  $scope.ORfullscreen = "reduced-cons-card";
  $scope.XORIonContentConsumption = "ionContentConsumptionInit";
  $scope.timeActive = 1;
  $scope.graphActive = 0;
  $scope.todayTextSelector = $translate.instant('TODAY');
  $scope.older_than_a_week = false;

  var ctx;
  var dataGraph;
  var barData;
  var linesData;
  var myChart;
  var optionBar;
  var optionLine;
  var provider_logo;

  var daily_target_consumption_month = 0; //kWh
  var daily_target_consumption_year = 0; //kWh
  storage.print_target = false;

  var maxPower = [0, 0, 0, 0, 0]; //W
  var timeMaxPower = ""; //time
  var todayRatioAverage = [0, 0, 0, 0, 0];
  var alwaysOnPower = [0, 0, 0, 0, 0]; //W

  var alwaysOnEnergy_h = [0, 0, 0, 0, 0]; //kWh
  var fridgeEnergy_h = [0, 0, 0, 0, 0]; //kWh
  var waterheaterEnergy_h = [0, 0, 0, 0, 0]; //kWh
  var electricheaterEnergy_h = [0, 0, 0, 0, 0]; //kWh
  var electriccarEnergy_h = [0, 0, 0, 0, 0]; //kWh
  var cookingEnergy_h = [0, 0, 0, 0, 0]; //kWh
  var otherEnergy_h = [0, 0, 0, 0, 0]; //kWh
  var totalConsumption_h = [0, 0, 0, 0, 0]; //kWh

  var alwaysOnEnergy_l = [0, 0, 0, 0, 0]; //kWh
  var fridgeEnergy_l = [0, 0, 0, 0, 0]; //kWh
  var waterheaterEnergy_l = [0, 0, 0, 0, 0]; //kWh
  var electricheaterEnergy_l = [0, 0, 0, 0, 0]; //kWh
  var electriccarEnergy_l = [0, 0, 0, 0, 0]; //kWh
  var cookingEnergy_l = [0, 0, 0, 0, 0]; //kWh
  var otherEnergy_l = [0, 0, 0, 0, 0]; //kWh
  var totalConsumption_l = [0, 0, 0, 0, 0]; //kWh

  var todayPowerGraph = Array.apply(null, Array(24)).map(Number.prototype.valueOf,0);
  var weekPowerGraph = Array.apply(null, Array(7)).map(Number.prototype.valueOf,0);
  var monthPowerGraph = Array.apply(null, Array(31)).map(Number.prototype.valueOf,0);
  var yearPowerGraph = Array.apply(null, Array(12)).map(Number.prototype.valueOf,0);

  $scope.cards = [];
  $scope.todayPrice = Price.cur(Price.auto(totalConsumption_h[0],totalConsumption_l[0],1));
  var todayPrice = Price.cur(Price.auto(totalConsumption_h[0],totalConsumption_l[0],1));
  var todayConsumption = 0;
  var yesterdayPrice = 0;
  var yesterdayConsumption = 0;
  var sevenDaysPrice = 0;
  var sevenDaysConsumption = 0;
  var monthPrice = 0;
  var monthConsumption = 0;
  var yearPrice = 0;
  var yearConsumption = 0;
  var firm = "";

  $scope.$on('$ionicView.beforeLeave', function(){
    window.screen.orientation.lock('portrait');
  });

  if (storage.lastPriceCalculator){ lastPriceCalculator = storage.lastPriceCalculator; } else {lastPriceCalculator = 0; }

  var priceConsumption = function(whichTime){
      if (Date.now() - lastPriceCalculator > 600000 ){
        storage.lastPriceCalculator = Object.assign(Date.now());
        lastPriceCalculator = storage.lastPriceCalculator;
        console.log("more than an hour lastPriceCalculator")
        var now = new Date();
        now.setHours(0,0,0,0);
        storage.todayPrice = price_calculator({'date' : now, 'todayprice' : true})
        storage.todayConsumption = consumption_calculator({'date' : now, 'todayprice' : true});
        var yesterday = new Date(now);
        yesterday.setDate(now.getDate() - 1);
        yesterday.setHours(0,0,0,0);
        storage.yesterdayPrice = price_calculator({'date' : yesterday, 'todayprice' : true});
        var month = new Date(now.getFullYear(), now.getMonth(), 1);
        month.setHours(0,0,0,0);
        storage.monthPrice = price_calculator({'date' : month, 'monthprice' : true})
        var yearPrice = 0.0;
        var i;
        for (i=1; i<13; i++){
                var year = new Date(now.getFullYear(), i, 1);
                year.setHours(0,0,0,0);
                yearPrice = parseFloat(yearPrice) + parseFloat(price_calculator({'date' : year, 'monthprice' : true}).split(' ',1)  )
        }
        storage.yearPrice = Price.cur(yearPrice)
        var monday = getMonday(now);
        var sevenDaysPrice = 0.0;
        var i = 0;
        for (i=0; i<7; i++){
                var day = new Date(monday)
                day.setDate(monday.getDate() + i);
                day.setHours(0,0,0,0);
                sevenDaysPrice = parseFloat(sevenDaysPrice) +  parseFloat(price_calculator({'date' : day, 'todayprice' : true}).split(' ',1))
        }
        storage.sevenDaysPrice = Price.cur(sevenDaysPrice)
        Saving.save(null);
        lastPriceCalculator = Object.assign(Date.now());
      }
      restoreData();
      console.log("todayprice : ", storage.todayPrice)
      if (!storage.todayPrice | storage.todayConsumption == "0 kWh"){
        if (whichTime==0){
          console.log("Recommence")
          $timeout(function() {
            storage.lastPriceCalculator = 0;
            lastPriceCalculator = storage.lastPriceCalculator;
            Saving.save(null);
            priceConsumption(1);
          }, 3000);
        }
      }
  }

  if (storage.lastDownloadData) { lastDownloadData = storage.lastDownloadData; } else { lastDownloadData = 0; }

  $scope.$on("$ionicView.beforeEnter",function(){
    if(typeof analytics !== 'undefined') {
        analytics.identify(
            storage.Email, {
                name: storage.userName,
                email: storage.Email
        });
    }
    //if(typeof analytics !== 'undefined') { analytics.trackView($ionicHistory.currentStateName()); }
    if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName());}
    if(typeof intercom !== 'undefined') { intercom.registerIdentifiedUser({email: storage.Email}); }
    window.screen.orientation.unlock();
    $timeout(function(){
      $scope.todayTextSelector = $translate.instant('TODAY');
      // console.log("Today changed");
    },250);

    resConsumption = [];
    waiting_res=1;
    getAllConsumption().then(priceConsumption(0));
    resConsumptionForecast = [];
    waiting_res_forecast=1;
    getAllForecast();

    Globales.getContract().then(function(data){
      if(data==0){
        return;
      }
      else{
        storage.contract = JSON.stringify(data.contract);
        Saving.save(null);
      }
    });
    $timeout(function(){
      $scope.toggleTime($scope.timeActive);
      $scope.toggleGraph($scope.graphActive);
      $scope.updateLukoGraph();
      
      if (Date.now() - lastDownloadData > 600000){
        console.log("more than an hour downloadData")
        try{window.plugins.toast.showLongBottom($translate.instant("DOWNLOADINGDATA"))}catch(err){}
        storage.lastDownloadData = Object.assign(Date.now());
        lastDownloadData = storage.lastDownloadData;
        Saving.save(null);
        downloadData();
      }
      window.dispatchEvent(new Event('resize'));
    },100);
  });


  window.addEventListener("orientationchange", function() {
    $ionicLoading.show({duration : 1500});
    console.log(screen.orientation.type);
    $timeout(function(){$scope.updateLukoGraph(); },100)
    $timeout(function(){$ionicLoading.hide();},500)
  })




  var restoreData = function(){

    try {
      //// console.log(storage.consumptionData);
      downData = JSON.parse(storage.consumptionData);
      // console.log("data parsed")
    }
    catch(err) {
      downData=0;
      // console.log("data error")
    }

    if(downData != 0){
      $timeout(function(){
        $scope.older_than_a_week = downData.data.older_than_a_week;

        has_waterheater = downData.data.waterheater.has_one;
        has_electric_heater = downData.data.electric_heater.has_one;
        has_electric_car = downData.data.electric_car.has_one;
        //Now
        maxPower[0] = downData.data.now.max_power;
        alwaysOnPower[0] = downData.data.now.sleep_power;
        alwaysOnEnergy_h[0] = downData.data.now.alwaysOnEnergy;
        fridgeEnergy_h[0] = downData.data.now.fridgeEnergy;
        waterheaterEnergy_h[0] = downData.data.now.waterheaterEnergy;
        electricheaterEnergy_h[0] = downData.data.now.electricheaterEnergy;
        electriccarEnergy_h[0] = downData.data.now.electriccarEnergy;
        cookingEnergy_h[0] = downData.data.now.cookingEnergy;
        otherEnergy_h[0] = downData.data.now.otherEnergy;
        totalConsumption_h[0] = downData.data.now.total_consumption_h;
        totalConsumption_l[0] = downData.data.now.total_consumption_l;
        //Today
        maxPower[1] = downData.data.today.max_power;
        alwaysOnPower[1] = downData.data.today.sleep_power;
        alwaysOnEnergy_h[1] = downData.data.today.alwaysOnEnergy_h;
        fridgeEnergy_h[1] = downData.data.today.fridgeEnergy_h;
        waterheaterEnergy_h[1] = downData.data.today.waterheaterEnergy_h;
        electricheaterEnergy_h[1] = downData.data.today.electricheaterEnergy_h;
        electriccarEnergy_h[1] = downData.data.today.electriccarEnergy_h;
        cookingEnergy_h[1] = downData.data.today.cookingEnergy_h;
        otherEnergy_h[1] = downData.data.today.otherEnergy_h;
        totalConsumption_h[1] = downData.data.today.total_consumption_h;
        alwaysOnEnergy_l[1] = downData.data.today.alwaysOnEnergy_l;
        fridgeEnergy_l[1] = downData.data.today.fridgeEnergy_l;
        waterheaterEnergy_l[1] = downData.data.today.waterheaterEnergy_l;
        electricheaterEnergy_l[1] = downData.data.today.electricheaterEnergy_l;
        electriccarEnergy_l[1] = downData.data.today.electriccarEnergy_l;
        cookingEnergy_l[1] = downData.data.today.cookingEnergy_l;
        otherEnergy_l[1] = downData.data.today.otherEnergy_l;
        totalConsumption_l[1] = downData.data.today.total_consumption_l;
        // Week
        maxPower[2] = downData.data.week.max_power;
        alwaysOnPower[2] = downData.data.week.sleep_power;
        alwaysOnEnergy_h[2] = downData.data.week.alwaysOnEnergy_h;
        fridgeEnergy_h[2] = downData.data.week.fridgeEnergy_h;
        waterheaterEnergy_h[2] = downData.data.week.waterheaterEnergy_h;
        electricheaterEnergy_h[2] = downData.data.week.electricheaterEnergy_h;
        cookingEnergy_h[2] = downData.data.week.cookingEnergy_h;
        otherEnergy_h[2] = downData.data.week.otherEnergy_h;
        totalConsumption_h[2] = downData.data.week.total_consumption_h;
        alwaysOnEnergy_l[2] = downData.data.week.alwaysOnEnergy_l;
        fridgeEnergy_l[2] = downData.data.week.fridgeEnergy_l;
        waterheaterEnergy_l[2] = downData.data.week.waterheaterEnergy_l;
        electricheaterEnergy_l[2] = downData.data.week.electricheaterEnergy_l;
        electriccarEnergy_l[2] = downData.data.week.electriccarEnergy_l;
        cookingEnergy_l[2] = downData.data.week.cookingEnergy_l;
        otherEnergy_l[2] = downData.data.week.otherEnergy_l;
        totalConsumption_l[2] = downData.data.week.total_consumption_l;
        // Month
        maxPower[3] = downData.data.month.max_power;
        alwaysOnPower[3] = downData.data.month.sleep_power;
        alwaysOnEnergy_h[3] = downData.data.month.alwaysOnEnergy_h;
        fridgeEnergy_h[3] = downData.data.month.fridgeEnergy_h;
        waterheaterEnergy_h[3] = downData.data.month.waterheaterEnergy_h;
        electricheaterEnergy_h[3] = downData.data.month.electricheaterEnergy_h;
        electriccarEnergy_h[3] = downData.data.month.electriccarEnergy_h;
        cookingEnergy_h[3] = downData.data.month.cookingEnergy_h;
        otherEnergy_h[3] = downData.data.month.otherEnergy_h;
        totalConsumption_h[3] = downData.data.month.total_consumption_h;
        alwaysOnEnergy_l[3] = downData.data.month.alwaysOnEnergy_l;
        fridgeEnergy_l[3] = downData.data.month.fridgeEnergy_l;
        waterheaterEnergy_l[3] = downData.data.month.waterheaterEnergy_l;
        electricheaterEnergy_l[3] = downData.data.month.electricheaterEnergy_l;
        electriccarEnergy_l[3] = downData.data.month.electriccarEnergy_l;
        cookingEnergy_l[3] = downData.data.month.cookingEnergy_l;
        otherEnergy_l[3] = downData.data.month.otherEnergy_l;
        totalConsumption_l[3] = downData.data.month.total_consumption_l;
        // Years
        maxPower[4] = downData.data.year.max_power;
        alwaysOnPower[4] = downData.data.year.sleep_power;
        alwaysOnEnergy_h[4] = downData.data.year.alwaysOnEnergy_h;
        fridgeEnergy_h[4] = downData.data.year.fridgeEnergy_h;
        waterheaterEnergy_h[4] = downData.data.year.waterheaterEnergy_h;
        electricheaterEnergy_h[4] = downData.data.year.electricheaterEnergy_h;
        electriccarEnergy_h[4] = downData.data.year.electriccarEnergy_h;
        cookingEnergy_h[4] = downData.data.year.cookingEnergy_h;
        otherEnergy_h[4] = downData.data.year.otherEnergy_h;
        totalConsumption_h[4] = downData.data.year.total_consumption_h;
        alwaysOnEnergy_l[4] = downData.data.year.alwaysOnEnergy_l;
        fridgeEnergy_l[4] = downData.data.year.fridgeEnergy_l;
        waterheaterEnergy_l[4] = downData.data.year.waterheaterEnergy_l;
        electricheaterEnergy_l[4] = downData.data.year.electricheaterEnergy_l;
        electriccarEnergy_l[4] = downData.data.year.electriccarEnergy_l;
        cookingEnergy_l[4] = downData.data.year.cookingEnergy_l;
        otherEnergy_l[4] = downData.data.year.otherEnergy_l;
        totalConsumption_l[4] = downData.data.year.total_consumption_l;

        todayPowerGraph = downData.data.today.hour_consumption_UTC;
        weekPowerGraph = downData.data.week.week_consumption;
        monthPowerGraph = downData.data.month.month_consumption;
        yearPowerGraph = downData.data.year.year_consumption;

        provider_logo = downData.data.contract.cardHeaderIcon;
        firm = downData.data.contract.cardTitle;

        storage.print_target = downData.data.target.active;
        daily_target_consumption_month = downData.data.target.value_month;
        daily_target_consumption_year = downData.data.target.value_year;

        //$scope.todayPrice = Price.cur(Price.auto(totalConsumption_h[0],totalConsumption_l[0],1));


        $scope.todayPrice = storage.todayPrice;
        todayPrice = $scope.todayPrice;
        todayConsumption = storage.todayConsumption;
        yesterdayPrice = storage.yesterdayPrice;
        monthPrice = storage.monthPrice;
        yearPrice = storage.yearPrice;
        sevenDaysPrice = storage.sevenDaysPrice;

        updateCard();
      });
    }
  }

  var getMonday = function(d) {
      d = new Date(d);
      var day = d.getDay(),
          diff = d.getDate() - day + (day == 0 ? -6:1); // adjust when day is sunday
      return new Date(d.setDate(diff));
    }

    var downloadData = function(){
        lang = $translate.use();
        $scope.restoredata = false;
        Globales.getPower3(storage.token, lang).then(function(downData){
          if((downData == null) || (downData == "server_error")){
            try{window.plugins.toast.hide()}catch(err){}
            if(storage.consumptionTime==0){
                lastDataString = $translate.instant("NEVER")
            }
            else{
              lastDownloadData = Object.assign(Date.now());
              // console.log(storage.consumptionTime);
              timediff = Math.floor(Date.now() / 1000) - storage.consumptionTime;
              // console.log(timediff);
              if(timediff<60){
                timediff = timediff;
                lastDataString = timediff + " " + $translate.instant("SECONDS")
              }
              else if((timediff)<3600){
                timediff = Math.floor(timediff/60);
                lastDataString = timediff + " " + $translate.instant("MINUTES")
              }
              else if(timediff<(3600*24)){
                timediff = Math.floor(timediff/3600);
                lastDataString = timediff + " " + $translate.instant("HOURS")
              }
              else{
                timediff = Math.floor(timediff/(3600*24));
                lastDataString = timediff + " " + $translate.instant("DAYS")
              }
              if($translate.instant("INVERTED")=="false"){
                lastDataString = $translate.instant("AGOMIN") + " " + lastDataString;
              }
              else{
                lastDataString = lastDataString + " " + $translate.instant("AGOMIN");
              }
            }
            window.plugins.toast.hide();
            if(downData == "server_error"){
              window.plugins.toast.showWithOptions(
                {
                  message: $translate.instant("SERVERLASTDATA") + " " + lastDataString,
                  duration: 20000, // ms
                  position: "bottom",
                },
                function(result) {
                  if (result && result.event) {
                  if (result.event === 'touch') {
                    // console.log("touchedddddd");
                    window.plugins.toast.hide();
                  }
                }
              }
              );
            }
            else{
              window.plugins.toast.showWithOptions(
              {
                message: $translate.instant("NOINTERNETLASTDATA") + " " + lastDataString,
                duration: 20000, // ms
                position: "bottom",
              },
              function(result) {
                if (result && result.event) {
                if (result.event === 'touch') {
                  // console.log("touchedddddd");
                  window.plugins.toast.hide();
                }
                }
              }
            );
          }
      }
      else if(downData == "forbidden"){
        storage.token = "";
        Saving.save(null);
        $state.go('myLuko.login');
      }
      else if(downData.success){
        //// console.log(JSON.stringify(downData))
        storage.consumptionData = JSON.stringify(downData);
        storage.consumptionTime = Math.floor(Date.now() / 1000);
        Saving.save(null);
        try{window.plugins.toast.hide()}catch(err){}
        restoreData();
        try{window.plugins.toast.hide()}catch(err){}
      }
      else{
        $cordovaDialogs.confirm($translate.instant("YOURLUKOISNOTCONFIGUREDYET"), $translate.instant("WARNING"),  [$translate.instant("SETUPMYLUKO"),$translate.instant("CANCEL")]).then(function(data){
          if(data==1){
            $state.go('myLuko.settings');
          }
          else{
            storage.token = "";
            Saving.save(null);
            $state.go('login');
          }
        });
        return;
      }
    })
  }

  $scope.greyText = function(grey_text){
    if (grey_text){
      return("/" + $translate.instant("WEEK4LETTERS"));
    }
    else{
      return("");
    }
  }

  var updateCard = function(){
    if($scope.graphActive==0){
      // console.log("hihi")
      //use general cards
      var todayPriceValue = 0;
      var todayConsumptionValue = 0;
      if(($scope.timeActive==1)||($scope.timeActive==0)){
        todayPriceValue = todayPrice;
        todayConsumptionValue = todayConsumption;
        // console.log("today total");
        total_index = 0;
      }
      else{
        total_index = $scope.timeActive;
        todayPriceValue = Price.cur( Price.auto(totalConsumption_h[total_index], totalConsumption_l[total_index], Math.max($scope.timeActive,1)));
        todayConsumptionValue = Price.formatLargeNumber(totalConsumption_h[total_index]+totalConsumption_l[total_index], 2) + " kWh";
      }
      cardMaxPower ={
        iconId: "picto/2700_04.png",
        appliance_type: "max_power",
        name: $translate.instant("MAXPOWER"),
        subname: $translate.instant("AT") + " " + timeMaxPower,
        value: Price.formatLargeNumber(maxPower[$scope.timeActive]*1.0) + " W",
        subvalue: Price.cur(Price.auto(maxPower[$scope.timeActive]/1000,0,0)) + "/h",
        style: "",
        grey_text: false
      }
      if (timeMaxPower==""){
        cardMaxPower.subname = "";
      }

      cardAlwaysOn ={
        iconId: "picto/5300_04.png",
        appliance_type: "always_on",
        name: $translate.instant("ALWAYSON"),
        subname: "",
        value: Price.cur(Price.auto(alwaysOnPower[$scope.timeActive]/1000*24*7,0,0)),
        subvalue: Price.formatLargeNumber(alwaysOnPower[$scope.timeActive]*1.0, 0) + " W",
        style: "top-card",
        grey_text: true
      };

      cardContract = {
        iconId: provider_logo,
        appliance_type: "contract",
        name: $translate.instant("CONTRACTCOST") + " " + firm,
        subname: "",
        value: Price.cur(Price.auto(0,0,Math.max($scope.timeActive,1))),
        subvalue: "",
        grey_text: false
      };

      cardTotal ={
        iconId: "Total.svg",
        name: "Total",
        value:  todayPriceValue,
        subvalue: todayConsumptionValue,
        style: "grey-card buttom-card"// buttom-card"
      };

      $scope.cards = [cardAlwaysOn, cardMaxPower, cardContract];
      $scope.cardTotal = cardTotal;

    }
    else{
      var yesterdayPriceValue = 0;
      if($scope.timeActive==1){
        yesterdayPriceValue = yesterdayPrice;
      }
      else{
        total_index = $scope.timeActive;
        yesterdayPriceValue = Price.cur(Price.auto(totalConsumption_h[$scope.timeActive],totalConsumption_l[$scope.timeActive],$scope.timeActive));
      }
      // console.log("hoho")
      //use appliance cards
      cardSleepMode = {
        iconId: "picto/5300_04.png",
        appliance_type: "always_on",
        name: $translate.instant("ALWAYSON"),
        subname: "",
        value: Price.cur(Price.auto(alwaysOnEnergy_h[$scope.timeActive],alwaysOnEnergy_l[$scope.timeActive],0)),
        subvalue: Price.formatLargeNumber(alwaysOnEnergy_h[$scope.timeActive]+alwaysOnEnergy_l[$scope.timeActive], 0) + " kWh",
        style: "top-card",
        grey_text: false
      };
      cardFridge = {
        iconId: "picto/3100_04.png",
        appliance_type: "fridge",
        name: $translate.instant("FRIDGE"),
        subname: "",
        value: Price.cur(Price.auto(fridgeEnergy_h[$scope.timeActive],fridgeEnergy_l[$scope.timeActive],0)),
        subvalue: Price.formatLargeNumber(fridgeEnergy_h[$scope.timeActive]+fridgeEnergy_l[$scope.timeActive], 0) + " kWh",
        grey_text: false
      };
      cardCooking = {
        iconId: "picto/4400_04.png",
        appliance_type: "cooking",
        name: $translate.instant("COOKING"),
        subname: "",
        value: Price.cur(Price.auto(cookingEnergy_h[$scope.timeActive],cookingEnergy_l[$scope.timeActive],0)),
        subvalue: Price.formatLargeNumber(cookingEnergy_h[$scope.timeActive]+cookingEnergy_l[$scope.timeActive], 0) + " kWh",
        grey_text: false
      };
      cardWH = {
        iconId: "picto/5700_04.png",
        appliance_type: "waterheater",
        name: $translate.instant("WATERHEATER"),
        subname: "",
        value: Price.cur(Price.auto(waterheaterEnergy_h[$scope.timeActive],waterheaterEnergy_l[$scope.timeActive],0)),
        subvalue: Price.formatLargeNumber(waterheaterEnergy_h[$scope.timeActive]+waterheaterEnergy_l[$scope.timeActive], 0) + " kWh",
        grey_text: false
      };
      cardEH = {
        iconId: "picto/4200_04.png",
        appliance_type: "electric_heater",
        name: $translate.instant("ELECTRIC HEATER"),
        subname: "",
        value: Price.cur(Price.auto(electricheaterEnergy_h[$scope.timeActive],electricheaterEnergy_l[$scope.timeActive],0)),
        subvalue: Price.formatLargeNumber(electricheaterEnergy_h[$scope.timeActive]+electricheaterEnergy_l[$scope.timeActive], 0) + " kWh",
        grey_text: false
      };
      cardECar = {
        iconId: "picto/3500_04.png",
        appliance_type: "electric_car",
        name: $translate.instant("ELECTRIC CAR"),
        subname: "",
        value: Price.cur(Price.auto(electriccarEnergy_h[$scope.timeActive],electriccarEnergy_l[$scope.timeActive],0)),
        subvalue: Price.formatLargeNumber(electriccarEnergy_h[$scope.timeActive]+electriccarEnergy_l[$scope.timeActive], 0) + " kWh",
        grey_text: false
      };
      cardOther = {
        iconId: "picto/3700_04.png",
        appliance_type: "other",
        name: $translate.instant("OTHER"),
        subname: "",
        value: Price.cur(Price.auto(otherEnergy_h[$scope.timeActive],otherEnergy_l[$scope.timeActive],0)),
        subvalue: Price.formatLargeNumber(otherEnergy_h[$scope.timeActive]+otherEnergy_l[$scope.timeActive], 0) + " kWh",
        grey_text: false
      };

      cardContract = {
        iconId: provider_logo,
        appliance_type: "contract",
        name: $translate.instant("CONTRACTCOST"),
        subname: "",
        value: Price.cur(Price.auto(0,0,$scope.timeActive)),
        subvalue: "",
        grey_text: false
      };

      cardTotal ={
        iconId: "Total.svg",
        name: "Total",
        subname: "",// + $translate.instant("BELLOWAVERAGE"),
        value: Price.cur(Price.auto(totalConsumption_h[$scope.timeActive],totalConsumption_l[$scope.timeActive],$scope.timeActive)),
        subvalue: Price.formatLargeNumber(totalConsumption_h[$scope.timeActive]+totalConsumption_l[$scope.timeActive], 2) + " kWh",
        style: "grey-card buttom-card",// buttom-card"
        grey_text: false
      }
      if(($scope.timeActive==1)){
        cardTotal.subname = $translate.instant("YESTERDAY");
      }
      $scope.cards = [cardSleepMode, cardFridge, cardCooking];
      if(has_waterheater){
        $scope.cards.push(cardWH);
      };
      if(has_electric_heater){
        $scope.cards.push(cardEH);
      };
      if(has_electric_car){
        $scope.cards.push(cardECar);
      }
      $scope.cards.push(cardOther);
      $scope.cards.push(cardContract);
      $scope.cardTotal = cardTotal;
    }
  }

  var initToggleGraph = function(){
    $scope.ORfullscreen = "reduced-cons-card";
    $scope.XORIonContentConsumption = "ionContentConsumptionReduced";
    $scope.graphActive = 0;
    updateCard();
  }

  var isTracking = false;

  $scope.toggleGraph = function(id){
    var graph = "";
    switch(id){
      case 0:
        graph = ":GRAPH";
        break;
      case 1:
        graph = ":BUBBLES";
        break;
      case 2:
        graph = ":CARDS";
        break;
      default:
        break;
    }

    if (isTracking == false){
      isTracking = true;
      if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName() + graph);}
      $timeout(isTracking=false, 1000);
    }
    

    // IF changed the graph active
    if(id != $scope.graphActive) {

      // If the user switch to list view
      if (id == 2) {  
        window.screen.orientation.lock('portrait');
        // If the current menu is on NOW, switch to TODAY
        if($scope.timeActive == 0){ $scope.toggleTime(1); }
        // $scope.todayTextSelector = $translate.instant('YESTERDAYMAJ'); // ASK BENOIT
        $scope.todayTextSelector = $translate.instant('TODAY');
        $scope.ORfullscreen = "full-cons-card";
        $scope.XORIonContentConsumption = "ionContentConsumptionFull";
        XORfullscreenBoolean = true;
        $scope.doORfullscreen = false;
        $scope.graphActive = id;
      }

      // If it was o list view and the user switch to chart view
      else if(id === 0 || id === 1){
        window.screen.orientation.unlock();
        $scope.doORfullscreen = true;
        $timeout(function() {
          if($scope.doORfullscreen){
            console.log("reduced")
            $scope.ORfullscreen = "reduced-cons-card";
          }
        }, 200);
        $scope.XORIonContentConsumption = "ionContentConsumptionReduced";
        XORfullscreenBoolean = false;
        $scope.todayTextSelector = $translate.instant('TODAY');

        // Toggle graph view and load chart
        $scope.graphActive = id;
        $scope.toggleTime($scope.timeActive);
      }

      // Update luko_graph
      $scope.updateLukoGraph();

      // Update cards list
      updateCard();
    }
  }

  $scope.graphIcon = function(id){
    var graph_button_list = [
      "img/consumption/BarChart.svg",
      "img/consumption/BarChartBlue.svg",
      "img/consumption/BubleChart.svg",
      "img/consumption/BubleChartBlue.svg",
      "img/consumption/ListView.svg",
      "img/consumption/ListViewBlue.svg"
    ];
    if(id==3){
      if($scope.graphActive<2){
        return("white-line-active");
      }
      else{
        return("");
      }
    }
    else if(id==4){
      if($scope.graphActive>0){
        return("white-line-active");
      }
      else{
        return("");
      }
    }
    else if($scope.graphActive!=id){
      return(graph_button_list[2*id+1]);
    }
    else{
      return(graph_button_list[2*id]);
    }
  }


  $scope.goToApplianceCard = function(appliance_type){
    storage.currentCard = appliance_type;
    $state.go('myLuko.appliance');
  };

}])
