angular.module('app.controllers')

.controller('introCtrl', ['$timeout','$scope', '$state', '$window', 'Saving', '$translate','segment',// The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($timeout,$scope,$state,$window,Saving,$translate,segment) {
	var analytics = segment;
	var storage = window.localStorage;
	$scope.show_arrow = false;
	if ($translate.use() == 'fr-FR'){
		$scope.bubblespeech = "img/on_boarding/bubblespeech-fr.png";
	} else {
		$scope.bubblespeech = "img/on_boarding/bubblespeech-en.png";
	}

	if(typeof intercom !== 'undefined') { intercom.registerIdentifiedUser({email: storage.Email}); }

	$scope.swiperOptions = {
		effect: 'slide',
		initialSlide: 0,
		onInit: function(swiper){
			$scope.swiper = swiper;
		},
		onSlideChangeEnd: function(swiper){
			if (swiper.activeIndex == 1){
				$scope.showArrow();
			} 
			console.log('The active index is ' + swiper.activeIndex);
		}
	};

	$scope.$on("$ionicView.beforeEnter",function(){
		$scope.swiper.slideTo(0);
		console.log($scope.swiper);
	});

	$scope.settings = function(){
		storage.introDone = true;
		console.log("storage : " + storage.introDone)
		Saving.save(null);
		$state.go('myLuko.settings');
	}

	$scope.supportOpen = function(){
	    console.log("support");
	    intercom.displayMessenger();
	    $scope.show_arrow=false;
	    console.log('Show intercom')
	};


	$scope.showArrow = function(){
      $scope.show_arrow = false;
      $timeout(function() {
         $scope.show_arrow = true;
      }, 1000);
	};


    }

]);
