angular.module('app.controllers')


.controller('settingsCtrl', ['$scope', '$stateParams', 'Option', '$http', '$state','$ionicHistory','Saving', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams,Option,$http,$state,$ionicHistory,Saving) {
    var storage = window.localStorage;
    $scope.server = {};
    $scope.data = {};
    $scope.data.deviceID = "Please, setup your Luko";

    $scope.change = function(){
        $scope.server['time_since_home'] = $scope.server['dateSinceHome'].getTime();
        //console.log($scope..server );  
        Option.setOption(storage.token, $scope.server).then(function(out){console.log(out);});     
    }
    
    $scope.setup = function(){
        $state.go('myLuko.setupStart');
    }
    
    $scope.reset = function(){
        storage.clear();
        Saving.save(null);
        $state.go('login');
    }

    $scope.$on("$ionicView.beforeEnter", function(event, data){
        $scope.data.deviceID = "Please, setup your Luko";
        Option.getOption(storage.token).then(function(out){
            //console.log(out);
            $scope.server = out;
            $scope.server['dateSinceHome'] = new Date($scope.server ['time_since_home']);
        }); 
    });
    $scope.$on("$ionicView.afterEnter",function(){
        //if(typeof analytics !== 'undefined') { analytics.trackView($ionicHistory.currentStateName()); } 
        analytics.track($ionicHistory.currentStateName());
    });
    $scope.homesettings = function(){
        $state.go('myLuko.homesettings');
    }
    $scope.mytarget = function(){
        storage.currentCard = "myTarget";
        $state.go('myLuko.appliance');
    }
    $scope.status = function(){
        $state.go('myLuko.status');
    }


}
])
