angular.module('app.controllers')

.controller('signUpCtrl', ['Saving','$scope', '$stateParams', 'Globales', '$ionicPopup', '$state', '$ionicHistory', '$translate', '$timeout', '$cordovaDialogs',
'$ionicHistory','$ionicScrollDelegate', 'Option','segment',// The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function (Saving, $scope, $stateParams, Globales, $ionicPopup, $state, $ionicHistory, $translate, $timeout, $cordovaDialogs, 
    $ionicHistory, $ionicScrollDelegate, Option,segment) {
    var analytics = segment;

    function validateEmail(email) {
        var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return re.test(email);
    }

    var storage = window.localStorage;

    $scope.classBackgroundStyle = {
            height:  window.innerHeight+"px",
    };

     $scope.data = {
        name: '',
        eMail: storage.getItem('Email'),
        Phone: '',
        mdp: '',
        mdp2: ''
     }
    //if(typeof analytics !== 'undefined') { analytics.trackView($ionicHistory.currentStateName()); }
    analytics.track("APP :" + $ionicHistory.currentStateName());

    var keyboardShowHandler = function(open){
        $scope.$apply(function(){$scope.keyboardOpen = open;});
        if(open){
            $ionicScrollDelegate.scrollTop(true);
            $ionicScrollDelegate.freezeScroll(false);
            if(ionic.Platform.isIOS()){ 
                console.log("up"); 
                $scope.$apply(function(){$scope.styleInputSignup.top= '40vh';});
            } 
        }
        else{
            if(ionic.Platform.isIOS()){ 
                console.log("down"); 
                $scope.$apply(function(){$scope.styleInputSignup.top= '6vh';});
            } 
            $ionicScrollDelegate.scrollTop(false);
            $timeout(function(){
                $ionicScrollDelegate.freezeScroll(true);
                $ionicScrollDelegate.scrollTop(false);
            },200);
        }
        console.log("hello" + open)
    };
    var kSHTrue = function(){keyboardShowHandler(true);};
    var kSHFalse = function(){keyboardShowHandler(false);};

    $scope.submitting = false;
    $scope.keyboardOpen = false;

    $scope.$on("$ionicView.beforeEnter",function(){
        var storage = window.localStorage;

        window.removeEventListener('native.keyboardshow', kSHTrue);
        window.removeEventListener('native.keyboardhide', kSHFalse);
        window.addEventListener('native.keyboardshow', kSHTrue);
        window.addEventListener('native.keyboardhide', kSHFalse);

        //if(typeof analytics !== 'undefined') { analytics.trackView($ionicHistory.currentStateName()); }
        console.log("signup")
        analytics.track("APP :" + $ionicHistory.currentStateName());

        $scope.submitting = false;
        $scope.keyboardOpen = false;
        //$scope.keyboardOpen = true;
        keyboardShowHandler(false);
        //keyboardShowHandler(true);
    });

    $scope.back = function(){
        console.log("hello");
        window.history.go(-1);
    };

    $scope.submit = function(){
        console.log("submitting ...");
        if($scope.submitting){
            console.log("already submitting something ...");
            return
        }
        $scope.submitting = true;
        if(!validateEmail($scope.data.eMail)){
            $cordovaDialogs.alert($translate.instant("YOUREMAILISWRONG"), $translate.instant("SADLY")).then(function() {
                $scope.submitting = false;
            });
        }
        else if ($scope.data.mdp.length < 6){
            console.log("password small");
            $cordovaDialogs.alert($translate.instant("PASSWORDTOOSMALL"), $translate.instant("SADLY")).then(function() {
                $scope.submitting = false;
            });
        }
        else if($scope.data.mdp!=$scope.data.mdp2){
            $cordovaDialogs.alert($translate.instant("PASSWORDDIFFERENTS"), $translate.instant("SADLY")).then(function() {
                $scope.submitting = false;
            });
        }
        else{
            console.log('in scope');
            console.log($scope.data);
            storage.Email =  $scope.data.eMail;
            Globales.signNewUser($scope.data).then(function(out){
                if(out == 0){
                    $scope.submitting = false;
                    $cordovaDialogs.alert($translate.instant("YOUNEEDTOBECONNECTEDTOINTERNET"), $translate.instant("SADLY"));
                }
                else{
                    if(out.good === 1){
                       storage.Email =  $scope.data.eMail;
                       $scope.securLog={}
                       $scope.securLog.Email = $scope.data.eMail;
                       $scope.securLog.Password = $scope.data.mdp;
                       $scope.data = {
                            name: '',
                            eMail: storage.Email,
                            Phone: '',
                            mdp: '',
                            mdp2: ''
                        }
                        $scope.submitting = false;
                        $cordovaDialogs.alert($translate.instant("YOURACCOUNTHASJUSTBEENCREATED"), $translate.instant("NICE")).then(function() {
                            console.log('in scope');
                            console.log(out);

                            Globales.logIn($scope.securLog).then(function(out){
                                if(out == 0){
                                    $scope.submitting = false;
                                    $cordovaDialogs.alert($translate.instant('YOUNEEDTOBECONNECTEDTOINTERNET'), $translate.instant("SADLY"));
                                }
                                else{
                                    if(out.good === 1){
                                        $scope.submitting = false;
                                        var datapass = {
                                            key : out.token
                                        };
                                        $scope.securLog = {
                                            Email: storage.getItem('Email'),
                                            Password: '',
                                        };
                                        if(ionic.Platform.isIOS()){
                                          var platformString = "IOS";
                                        }
                                        else if (ionic.Platform.isAndroid()){
                                          var platformString = "GCM";
                                        }
                                        else{
                                          var platformString = "OTHER";
                                        }
                                        storage.setItem('token', out.token); // Pass a key name and its value to add or update that key.
                                        Saving.save(null);
                                        try{
                                            cordova.getAppVersion.getVersionNumber().then(function (version) {
                                              $http.post('https://app.getluko.com/msg/subscribePush', {token: storage.registrationId, platform: platformString, user_id: storage.token, appversion: version, language: $translate.use()})
                                              .success(function(data){
                                              })
                                              .error(function(err){
                                              });
                                            });
                                        }
                                        catch(err){
                                            console.log("No app version : no notification !!");
                                        }
                                        if(typeof analytics !== 'undefined') {
                                            analytics.identify(storage.Email, {
                                                name: storage.userName,
                                                email: storage.Email
                                            });
                                        }

                                        Option.getDeviceID(storage.token).then(function(resp){ 
                                            console.log("resp : " + JSON.stringify(resp));
                                            if (resp.good != 0){ 
                                              console.log("luko validation : " + resp);
                                              console.log("Start with consumption"); 
                                              $state.go('myLuko.consumption').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                                            } 
                                            else { 
                                              console.log("Start with intro"); 
                                              $state.go('myLuko.intro').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                                              //$state.go('myLuko.intro').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                                            } 
                                        }) 
                                    }
                                    else {
                                        $scope.submitting = false;
                                        $cordovaDialogs.alert($translate.instant('YOUREMAILORPASSWORDISWRONG'), $translate.instant("SADLY"));
                                    }
                                    
                                } 
                            })



                            $state.go('login');
                        });
                    }
                    else {
                        $scope.submitting = false;
                        if (JSON.stringify(out.data).includes("This field is required")) {
                            $cordovaDialogs.alert($translate.instant("DATAREQUIRED"), $translate.instant("SADLY"));
                        } else {
                            $cordovaDialogs.alert($translate.instant("WENTWRONG"), $translate.instant("SADLY"));
                        }
                    }
                    $scope.submitting = false;
                }
            });
        }

    }

}])
