// Initialize the helpers class
gViz.shared.helpers.array = {

  // Filter unique values
  unique: function(array, prop) {
    var uniqueValues = {};
    return array.filter(function(d) {
      var flag = uniqueValues[d[prop]] == null;
      uniqueValues[d[prop]] = true;
      return flag;
    });
  },

  // Sort values
  sorted: function(array, prop, order='ascending') {
    return array.sort(function(a,b) { return d3[order](a[prop], b[prop]); });
  }

};
