var queue = [];

// Initialize the helpers class¬
gViz.shared.helpers.loading = {

  // Update loading div
  update: function(target) {
    if(target != null) {
      d3.select(target).selectAll('.loading-div .loading-div-inner')
        .style('height', $(target).outerHeight() + "px")
        .style('line-height', $(target).outerHeight() + "px")
        .style('width',  $(target).outerWidth() + "px");
    }
  },

  // Mostra loading div
  show: function(target) {

    if(target != null) {

     var string  = "<div class='showbox'>"
      string += "<div class='loader'>"
      string += "<svg class='circular' viewBox='25 25 50 50'>"
      string += "<circle class='path' cx='50' cy='50' r='20' fill='none' stroke-width='2' stroke-miterlimit='10'/>"
      string += "</svg>"
      string += "</div>"
      string += "</div>"

      // Create / Update loading div
      var loadingDiv = d3.select(target).selectAll('.loading-div').data(["loading-div"]);
      loadingDiv.exit().remove();
      loadingDiv = loadingDiv.enter().append("div").attr("class", 'loading-div').merge(loadingDiv);
      loadingDiv
        .style('display','block')
        .html("<div class='loading-div-inner'>"+string+"</div>");

       // Show loading div
      loadingDiv.selectAll(".loading-div-inner")
        .style('height', $(target).outerHeight() + "px")
        .style('line-height', $(target).outerHeight() + "px")
        .style('width',  $(target).outerWidth() + "px");

      // Remove scroll
      // d3.select(target).classed("no-scroll", true);

    }
  },

  // Some com loading div
  hide: function(target) {
    if(target != null) {
      d3.select(target).selectAll('.loading-div').remove();;
      // d3.select(target).classed("no-scroll", false);
    }
  }

};
